<template>
  <PageContainer>
    <template slot="cp_search">
      <SearchPanel
        v-model="search"
        :columns="columns"
      />
    </template>
    <template slot="header">
      <MControlPanel
        state="list"
        :can-create="canCreate"
        @on-state-button-clicked="viewForm(null)"
        :actions="actions"
        :display.sync="display"
        :selected="selected">
      </MControlPanel>
    </template>

    <template slot="content" style="background-color: white">
      <MTable
        row-key="id"
        :data-source="items"
        :columns="columns"
        :display-view="display"
        :selected.sync="selected"
        :m-loading="loading"
        :m-filter="search"
        :pagination="pagination"
        @request="onRequest"
        @on-row-clicked="viewForm">
        <template v-slot:disabled_at="slotProps">
          <div style="display: inline-block; text-align: center">
            <q-chip v-if="!slotProps.props.row.disabled_at" class="" color="green" dense
                    icon="la la-check-circle" label="actif" square text-color="secondary"/>
            <q-chip v-else class="" color="red" dense
                    icon="la la-times" label="inactif" square text-color="secondary"/>
          </div>
        </template>
      </MTable>
    </template>
  </PageContainer>
</template>

<script>
import PageContainer from "components/PageContainer";
import MTable from "components/datatables/MTable";
import MControlPanel from "components/MControlPanel";
import MSearchTable from "components/datatables/MSearchTable";
import {mapActions, mapState} from "vuex";
import get from 'lodash/get'
import SearchPanel from "components/datatables/SearchPanel";
import Helpers from "src/mixins/helpers";
import UserPasswordChangeDialog from "pages/administration/users/components/UserPasswordChangeDialog";

export default {
  name: "UsersIndex",
  components: {SearchPanel, MSearchTable, MControlPanel, MTable, PageContainer},
  mixins: [Helpers],
  data() {
    return {
      search: null,
      pagination: {
        sortBy: 'created_at',
        descending: true,
        page: 1,
        rowsPerPage: 10,
      },
      columns: [
        {
          name: 'id', field: 'id', label: 'Id', align: 'left',
          visible: true, sortable: true, searchable: true, type: 'number'
        },
        {
          name: 'username', field: 'username', label: 'Identifiant', align: 'left',
          visible: true, sortable: true, searchable: true, type: 'text',
        },
        {
          name: 'full_name', field: 'full_name', label: 'Nom & Prénom', align: 'left',
          visible: true, sortable: true, searchable: true, type: 'text',
        },
        {
          name: 'email', field: 'email', label: 'E-mail', align: 'left',
          visible: true, sortable: true, searchable: true,
        },
        {
          name: 'phone', field: 'phone', label: 'Téléphone', align: 'left',
          visible: true, sortable: true, searchable: true, type: 'text',
        },
        {
          name: 'type', field: 'type', label: 'Type', align: 'left',
          visible: true, sortable: true, searchable: true, type: 'text',
        },
        {
          name: 'disabled_at', field: 'disabled_at', type: 'boolean', label: 'Statut', align: 'left', slot: true,
          visible: true, sortable: false, searchable: false,
        },
        {
          name: 'createdAt', field: row => this._formatDate(row.createdAt), sortable: true,
          label: 'Créé le', align: 'left', visible: false,
        },
      ],
      loading: false,
      selected: [],
      grid: false,
      display: '',
    }
  },

  methods: {
    viewForm(row) {
      this.$router.push({
        name: 'users_form',
        params: {type: row ? 'view' : 'create', id:  get(row, 'id')},
      })
    },

    async onRequest(props) {
      this.loading = true
      try {
        let results = await this.$store.dispatch('users/index', props)
        this.loading = false
        this.pagination = {
          ...props.pagination,
          rowsNumber: parseInt(results.total),
        }
      } catch (reason) {
        this.loading = false
      }
    },

    onChangePassword() {
      this.$q.dialog({
        parent: this,
        component: UserPasswordChangeDialog,
        user: this.selectedRow,
        state: 'update',
      }).onOk(() => {
        console.log('Amen!')
      })
    },
    onDeleteRow() {
      this.$q.dialog({
        parent: this,
        cancel: true,
        title:'Suppression',
        message: 'Disponible bientôt!'
      }).onOk(() => {
        console.log('Amen!')
      })
    },
    async fetchList() {
      await this.onRequest({
        pagination: this.pagination,
        filter: this.search,
      })
    },

    async onChangeUserState() {
      if (this.selectedRow) {
        this.$q.dialog({
          title: 'Confirmation',
          message: `Voulez-vous ${!!this.selectedRow.disabled_at ? 'activer' : 'désactiver'} ${this.selectedRow.full_name} ?`,
          cancel: true,
        }).onOk(async () => {
          await this.$store.dispatch('users/activeOrDisable', {
            id: this.selectedRow.id,
            status: !this.selectedRow.disabled_at
          }).then(() => {
            this.selected.splice(0, this.selected.length)
            this.Motify('success', 'Fait!')
            this.fetchList()
          }).catch((err) => {
            this.Motify('error', this._getErrorMessage(err))
          })
        })
      }
    },
  },

  computed: {
    canCreate() {
      return true
    },
    canUpdate() {
      return true
    },

    actions() {
      return [
        {
          label: `${!!(this.selectedRow.disabled_at) ? 'Activer' : 'Désactiver'} l'utilisateur`,
          func: this.onChangeUserState,
          display: true,
        },
        {
          label: 'Changer le mot de passe',
          func: this.onChangePassword,
          display: true,
        },
        {
          label: 'Supprimer l\'utilisateur',
          func: this.onDeleteRow,
          display: true,
        },
      ]
    },

    selectedRow() {
      return _.get(this.selected, '0', {}) || {}
    },

    ...mapState({
      baseUrl: state => state.users.baseUrl,
      items: state => get(state, 'users.items.data', []) || [],
    })
  },
  async mounted() {
    await this.fetchList()
  },
}
</script>

<style scoped>

</style>
